<template>
    <v-row>
        <v-col>
            <data-table
                v-model="items"
                endpoint="api/affiliates/payout"
                :title="$t('monthly_payout')"
                :headers="headers"
                :filters="filters"
                :searchable="false"
            >
                <template v-slot:buttons>
                    <download-excel
                        :data="items"
                        :fields="excelFields"
                        :name="excelName"
                        type="xls"
                    >
                        <v-btn class="primary">
                            <v-icon>mdi-download</v-icon>
                            {{ $t('excel') }}
                        </v-btn>
                    </download-excel>
                </template>

                <template v-slot:filters="{ filters }">
                    <v-col cols="4">
                        <v-menu
                            v-model="payoutDateMenu"
                            :close-on-content-click="false"
                            transition="scale-transition"
                            min-width="290px"
                        >
                            <template v-slot:activator="{ on, attrs }">
                                <v-text-field
                                    v-model="filters.createdAt.value"
                                    prepend-icon="mdi-calendar"
                                    v-bind="attrs"
                                    v-on="on"
                                    readonly
                                    hide-details
                                    outlined
                                ></v-text-field>
                            </template>
                            <v-date-picker
                                type="month"
                                v-model="filters.createdAt.value"
                                @input="payoutDateMenu = false"
                            >
                            </v-date-picker>
                        </v-menu>
                    </v-col>
                    <v-col cols="4">
                        <v-payout-status-select
                            v-model="filters.paidStatus.value"
                            :placeholder="$t('filter_by', [$t('status')])"
                            :clearable="true"
                        >
                        </v-payout-status-select>
                    </v-col>
                </template>

                <template v-slot:item="{ item }">
                    <tr @click="openDialog(item)">
                        <td>{{ item.name }}</td>
                        <td>{{ item.email }}</td>
                        <td>{{ item.mobile }}</td>
                        <td class="text-right">{{ item.commission_sum | currency }} MYR</td>
                        <td>
                            <v-icon :color="item.paid ? 'green' : 'error'">
                                {{ item.paid ? 'check' : 'close' }}
                            </v-icon>
                        </td>
                        <td class="text-center">{{ item.reference_no === null ? '-' : item.reference_no }}</td>
                        <td>{{ item.date | monthYear(momentLocale) }}</td>
                    </tr>
                </template>
            </data-table>
        </v-col>

        <v-dialog
            v-model="dialog"
            persistent
            max-width="300"
        >
            <v-card>
                <v-card-title class="headline primary white--text">
                    {{ $t('monthly_payout') }}
                </v-card-title>

                <v-card-text class="pt-2">
                    <p class="mb-2">{{ $t('payout_desc_1') }}</p>
                    <p>{{ $t('payout_desc_2') }}</p>

                    <v-container>
                        <v-row>
                            <v-col>
                                <div class="field-label">{{ $t('ref_no') }}</div>
                                <ValidationObserver ref="observer" v-slot="{ validate, reset }">
                                    <ValidationProvider v-slot="{ errors }" name="ref_no" rules="required">
                                        <v-text-field
                                            v-model="marking.reference_no"
                                            :error-messages="errors"
                                            hide-details="auto"
                                            outlined
                                        >
                                        </v-text-field>
                                    </ValidationProvider>
                                </ValidationObserver>
                            </v-col>
                        </v-row>
                    </v-container>
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>

                    <v-btn
                        class="error"
                        color="white"
                        text
                        @click="closeDialog"
                    >
                        {{ $t('no') }}
                    </v-btn>

                    <v-btn
                        class="primary"
                        color="white"
                        text
                        :loading="submit"
                        @click="markPayout"
                    >
                        {{ $t('yes') }}
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </v-row>
</template>

<script>
    import { ValidationObserver, ValidationProvider } from 'vee-validate';
    import DataTable from "../DataTable";
    import util from "../../../mixins/util";
    import moment from "moment";
    import VPayoutStatusSelect from "../VPayoutStatusSelect";

    export default {
        name: "Payout",

        components: {VPayoutStatusSelect, DataTable, ValidationObserver, ValidationProvider},

        mixins: [ util ],

        data: () => ({
            dialog: false,
            payoutDateMenu: false,
            loading: false,
            submit: false,
            marking: null,
            items: [],
            filters: {
                createdAt: {
                    field: 'created_at',
                    value: moment().format('YYYY-MM')
                },
                paidStatus: {
                    field: 'paid',
                    value: null
                }
            },
        }),

        computed: {
            excelFields() {
                return {
                    'Name': 'name',
                    'Email': 'email',
                    'Mobile': 'mobile',
                    'Amount': {
                        field: 'commission_sum',
                        callback: (value) => {
                            return `${value} MYR`;
                        }
                    },
                    'Paid': {
                        field: 'paid',
                        callback: (value) => {
                            return value ? 'Yes' : 'No';
                        }
                    },
                    'Reference Number': 'reference_no',
                    'Date': 'date'
                }
            },

            excelName() {
                return 'dna_payout.xls';
            },

            headers() {
                return [
                    { text: this.$t('name'), value: 'name', sortable: false },
                    { text: this.$t('email'), value: 'name', sortable: false },
                    { text: this.$t('mobile'), value: 'name', sortable: false },
                    { text: this.$t('amount'), value: 'amount', align: 'right', sortable: false },
                    { text: this.$t('paid'), value: 'paid', sortable: false },
                    { text: this.$t('ref_no'), value: 'reference_no', align: 'center', sortable: false },
                    { text: this.$t('date'), value: 'date', sortable: false },
                ]
            },
        },

        methods: {
            openDialog(item) {
                this.marking = item;
                this.dialog = true;
            },

            closeDialog() {
                this.dialog = false;
                this.marking = null;
                this.$refs.observer.reset();
            },

            markPayout() {
                this.submit = true;

                this.$refs.observer.validate()
                    .then(valid => {
                        if(valid) {
                            axios.post('api/affiliate/payout/' + this.marking.affiliate_id, {
                                date: this.marking.date,
                                reference_no: this.marking.reference_no
                            })
                                .then(() => {
                                    this.marking.paid = 1;
                                    this.marking = null;
                                    this.dialog = false;
                                    this.submit = false;
                                })
                                .catch(() => {
                                    this.submit = false;
                                })
                        }
                        else {
                            this.submit = false;
                        }
                    });
            }
        }
    }
</script>

<style scoped>

</style>
